package org.eclipse.gef.dot.internal.ide.language.contentassist.antlr.internal;
import java.util.Map;
import java.util.HashMap;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.gef.dot.internal.language.services.DotRectGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDotRectParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "Comma", "RULE_DOUBLE", "RULE_WS"
    };
    public static final int Comma=4;
    public static final int RULE_DOUBLE=5;
    public static final int RULE_WS=6;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDotRectParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDotRectParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDotRectParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDotRectParser.g"; }


    	private DotRectGrammarAccess grammarAccess;
    	private final Map<String, String> tokenNameToValue = new HashMap<String, String>();
    	
    	{
    		tokenNameToValue.put("Comma", "','");
    	}

    	public void setGrammarAccess(DotRectGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		String result = tokenNameToValue.get(tokenName);
    		if (result == null)
    			result = tokenName;
    		return result;
    	}



    // $ANTLR start "entryRuleRect"
    // InternalDotRectParser.g:56:1: entryRuleRect : ruleRect EOF ;
    public final void entryRuleRect() throws RecognitionException {
        try {
            // InternalDotRectParser.g:57:1: ( ruleRect EOF )
            // InternalDotRectParser.g:58:1: ruleRect EOF
            {
             before(grammarAccess.getRectRule()); 
            pushFollow(FOLLOW_1);
            ruleRect();

            state._fsp--;

             after(grammarAccess.getRectRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleRect"


    // $ANTLR start "ruleRect"
    // InternalDotRectParser.g:65:1: ruleRect : ( ( rule__Rect__Group__0 ) ) ;
    public final void ruleRect() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:69:2: ( ( ( rule__Rect__Group__0 ) ) )
            // InternalDotRectParser.g:70:2: ( ( rule__Rect__Group__0 ) )
            {
            // InternalDotRectParser.g:70:2: ( ( rule__Rect__Group__0 ) )
            // InternalDotRectParser.g:71:3: ( rule__Rect__Group__0 )
            {
             before(grammarAccess.getRectAccess().getGroup()); 
            // InternalDotRectParser.g:72:3: ( rule__Rect__Group__0 )
            // InternalDotRectParser.g:72:4: rule__Rect__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Rect__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getRectAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleRect"


    // $ANTLR start "rule__Rect__Group__0"
    // InternalDotRectParser.g:80:1: rule__Rect__Group__0 : rule__Rect__Group__0__Impl rule__Rect__Group__1 ;
    public final void rule__Rect__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:84:1: ( rule__Rect__Group__0__Impl rule__Rect__Group__1 )
            // InternalDotRectParser.g:85:2: rule__Rect__Group__0__Impl rule__Rect__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Rect__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__0"


    // $ANTLR start "rule__Rect__Group__0__Impl"
    // InternalDotRectParser.g:92:1: rule__Rect__Group__0__Impl : ( ( rule__Rect__LlxAssignment_0 ) ) ;
    public final void rule__Rect__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:96:1: ( ( ( rule__Rect__LlxAssignment_0 ) ) )
            // InternalDotRectParser.g:97:1: ( ( rule__Rect__LlxAssignment_0 ) )
            {
            // InternalDotRectParser.g:97:1: ( ( rule__Rect__LlxAssignment_0 ) )
            // InternalDotRectParser.g:98:2: ( rule__Rect__LlxAssignment_0 )
            {
             before(grammarAccess.getRectAccess().getLlxAssignment_0()); 
            // InternalDotRectParser.g:99:2: ( rule__Rect__LlxAssignment_0 )
            // InternalDotRectParser.g:99:3: rule__Rect__LlxAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Rect__LlxAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getRectAccess().getLlxAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__0__Impl"


    // $ANTLR start "rule__Rect__Group__1"
    // InternalDotRectParser.g:107:1: rule__Rect__Group__1 : rule__Rect__Group__1__Impl rule__Rect__Group__2 ;
    public final void rule__Rect__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:111:1: ( rule__Rect__Group__1__Impl rule__Rect__Group__2 )
            // InternalDotRectParser.g:112:2: rule__Rect__Group__1__Impl rule__Rect__Group__2
            {
            pushFollow(FOLLOW_4);
            rule__Rect__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__1"


    // $ANTLR start "rule__Rect__Group__1__Impl"
    // InternalDotRectParser.g:119:1: rule__Rect__Group__1__Impl : ( Comma ) ;
    public final void rule__Rect__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:123:1: ( ( Comma ) )
            // InternalDotRectParser.g:124:1: ( Comma )
            {
            // InternalDotRectParser.g:124:1: ( Comma )
            // InternalDotRectParser.g:125:2: Comma
            {
             before(grammarAccess.getRectAccess().getCommaKeyword_1()); 
            match(input,Comma,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getCommaKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__1__Impl"


    // $ANTLR start "rule__Rect__Group__2"
    // InternalDotRectParser.g:134:1: rule__Rect__Group__2 : rule__Rect__Group__2__Impl rule__Rect__Group__3 ;
    public final void rule__Rect__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:138:1: ( rule__Rect__Group__2__Impl rule__Rect__Group__3 )
            // InternalDotRectParser.g:139:2: rule__Rect__Group__2__Impl rule__Rect__Group__3
            {
            pushFollow(FOLLOW_3);
            rule__Rect__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__2"


    // $ANTLR start "rule__Rect__Group__2__Impl"
    // InternalDotRectParser.g:146:1: rule__Rect__Group__2__Impl : ( ( rule__Rect__LlyAssignment_2 ) ) ;
    public final void rule__Rect__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:150:1: ( ( ( rule__Rect__LlyAssignment_2 ) ) )
            // InternalDotRectParser.g:151:1: ( ( rule__Rect__LlyAssignment_2 ) )
            {
            // InternalDotRectParser.g:151:1: ( ( rule__Rect__LlyAssignment_2 ) )
            // InternalDotRectParser.g:152:2: ( rule__Rect__LlyAssignment_2 )
            {
             before(grammarAccess.getRectAccess().getLlyAssignment_2()); 
            // InternalDotRectParser.g:153:2: ( rule__Rect__LlyAssignment_2 )
            // InternalDotRectParser.g:153:3: rule__Rect__LlyAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__Rect__LlyAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getRectAccess().getLlyAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__2__Impl"


    // $ANTLR start "rule__Rect__Group__3"
    // InternalDotRectParser.g:161:1: rule__Rect__Group__3 : rule__Rect__Group__3__Impl rule__Rect__Group__4 ;
    public final void rule__Rect__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:165:1: ( rule__Rect__Group__3__Impl rule__Rect__Group__4 )
            // InternalDotRectParser.g:166:2: rule__Rect__Group__3__Impl rule__Rect__Group__4
            {
            pushFollow(FOLLOW_4);
            rule__Rect__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__3"


    // $ANTLR start "rule__Rect__Group__3__Impl"
    // InternalDotRectParser.g:173:1: rule__Rect__Group__3__Impl : ( Comma ) ;
    public final void rule__Rect__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:177:1: ( ( Comma ) )
            // InternalDotRectParser.g:178:1: ( Comma )
            {
            // InternalDotRectParser.g:178:1: ( Comma )
            // InternalDotRectParser.g:179:2: Comma
            {
             before(grammarAccess.getRectAccess().getCommaKeyword_3()); 
            match(input,Comma,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getCommaKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__3__Impl"


    // $ANTLR start "rule__Rect__Group__4"
    // InternalDotRectParser.g:188:1: rule__Rect__Group__4 : rule__Rect__Group__4__Impl rule__Rect__Group__5 ;
    public final void rule__Rect__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:192:1: ( rule__Rect__Group__4__Impl rule__Rect__Group__5 )
            // InternalDotRectParser.g:193:2: rule__Rect__Group__4__Impl rule__Rect__Group__5
            {
            pushFollow(FOLLOW_3);
            rule__Rect__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__4"


    // $ANTLR start "rule__Rect__Group__4__Impl"
    // InternalDotRectParser.g:200:1: rule__Rect__Group__4__Impl : ( ( rule__Rect__UrxAssignment_4 ) ) ;
    public final void rule__Rect__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:204:1: ( ( ( rule__Rect__UrxAssignment_4 ) ) )
            // InternalDotRectParser.g:205:1: ( ( rule__Rect__UrxAssignment_4 ) )
            {
            // InternalDotRectParser.g:205:1: ( ( rule__Rect__UrxAssignment_4 ) )
            // InternalDotRectParser.g:206:2: ( rule__Rect__UrxAssignment_4 )
            {
             before(grammarAccess.getRectAccess().getUrxAssignment_4()); 
            // InternalDotRectParser.g:207:2: ( rule__Rect__UrxAssignment_4 )
            // InternalDotRectParser.g:207:3: rule__Rect__UrxAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__Rect__UrxAssignment_4();

            state._fsp--;


            }

             after(grammarAccess.getRectAccess().getUrxAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__4__Impl"


    // $ANTLR start "rule__Rect__Group__5"
    // InternalDotRectParser.g:215:1: rule__Rect__Group__5 : rule__Rect__Group__5__Impl rule__Rect__Group__6 ;
    public final void rule__Rect__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:219:1: ( rule__Rect__Group__5__Impl rule__Rect__Group__6 )
            // InternalDotRectParser.g:220:2: rule__Rect__Group__5__Impl rule__Rect__Group__6
            {
            pushFollow(FOLLOW_4);
            rule__Rect__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rect__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__5"


    // $ANTLR start "rule__Rect__Group__5__Impl"
    // InternalDotRectParser.g:227:1: rule__Rect__Group__5__Impl : ( Comma ) ;
    public final void rule__Rect__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:231:1: ( ( Comma ) )
            // InternalDotRectParser.g:232:1: ( Comma )
            {
            // InternalDotRectParser.g:232:1: ( Comma )
            // InternalDotRectParser.g:233:2: Comma
            {
             before(grammarAccess.getRectAccess().getCommaKeyword_5()); 
            match(input,Comma,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getCommaKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__5__Impl"


    // $ANTLR start "rule__Rect__Group__6"
    // InternalDotRectParser.g:242:1: rule__Rect__Group__6 : rule__Rect__Group__6__Impl ;
    public final void rule__Rect__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:246:1: ( rule__Rect__Group__6__Impl )
            // InternalDotRectParser.g:247:2: rule__Rect__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Rect__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__6"


    // $ANTLR start "rule__Rect__Group__6__Impl"
    // InternalDotRectParser.g:253:1: rule__Rect__Group__6__Impl : ( ( rule__Rect__UryAssignment_6 ) ) ;
    public final void rule__Rect__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:257:1: ( ( ( rule__Rect__UryAssignment_6 ) ) )
            // InternalDotRectParser.g:258:1: ( ( rule__Rect__UryAssignment_6 ) )
            {
            // InternalDotRectParser.g:258:1: ( ( rule__Rect__UryAssignment_6 ) )
            // InternalDotRectParser.g:259:2: ( rule__Rect__UryAssignment_6 )
            {
             before(grammarAccess.getRectAccess().getUryAssignment_6()); 
            // InternalDotRectParser.g:260:2: ( rule__Rect__UryAssignment_6 )
            // InternalDotRectParser.g:260:3: rule__Rect__UryAssignment_6
            {
            pushFollow(FOLLOW_2);
            rule__Rect__UryAssignment_6();

            state._fsp--;


            }

             after(grammarAccess.getRectAccess().getUryAssignment_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__Group__6__Impl"


    // $ANTLR start "rule__Rect__LlxAssignment_0"
    // InternalDotRectParser.g:269:1: rule__Rect__LlxAssignment_0 : ( RULE_DOUBLE ) ;
    public final void rule__Rect__LlxAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:273:1: ( ( RULE_DOUBLE ) )
            // InternalDotRectParser.g:274:2: ( RULE_DOUBLE )
            {
            // InternalDotRectParser.g:274:2: ( RULE_DOUBLE )
            // InternalDotRectParser.g:275:3: RULE_DOUBLE
            {
             before(grammarAccess.getRectAccess().getLlxDOUBLETerminalRuleCall_0_0()); 
            match(input,RULE_DOUBLE,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getLlxDOUBLETerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__LlxAssignment_0"


    // $ANTLR start "rule__Rect__LlyAssignment_2"
    // InternalDotRectParser.g:284:1: rule__Rect__LlyAssignment_2 : ( RULE_DOUBLE ) ;
    public final void rule__Rect__LlyAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:288:1: ( ( RULE_DOUBLE ) )
            // InternalDotRectParser.g:289:2: ( RULE_DOUBLE )
            {
            // InternalDotRectParser.g:289:2: ( RULE_DOUBLE )
            // InternalDotRectParser.g:290:3: RULE_DOUBLE
            {
             before(grammarAccess.getRectAccess().getLlyDOUBLETerminalRuleCall_2_0()); 
            match(input,RULE_DOUBLE,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getLlyDOUBLETerminalRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__LlyAssignment_2"


    // $ANTLR start "rule__Rect__UrxAssignment_4"
    // InternalDotRectParser.g:299:1: rule__Rect__UrxAssignment_4 : ( RULE_DOUBLE ) ;
    public final void rule__Rect__UrxAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:303:1: ( ( RULE_DOUBLE ) )
            // InternalDotRectParser.g:304:2: ( RULE_DOUBLE )
            {
            // InternalDotRectParser.g:304:2: ( RULE_DOUBLE )
            // InternalDotRectParser.g:305:3: RULE_DOUBLE
            {
             before(grammarAccess.getRectAccess().getUrxDOUBLETerminalRuleCall_4_0()); 
            match(input,RULE_DOUBLE,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getUrxDOUBLETerminalRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__UrxAssignment_4"


    // $ANTLR start "rule__Rect__UryAssignment_6"
    // InternalDotRectParser.g:314:1: rule__Rect__UryAssignment_6 : ( RULE_DOUBLE ) ;
    public final void rule__Rect__UryAssignment_6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDotRectParser.g:318:1: ( ( RULE_DOUBLE ) )
            // InternalDotRectParser.g:319:2: ( RULE_DOUBLE )
            {
            // InternalDotRectParser.g:319:2: ( RULE_DOUBLE )
            // InternalDotRectParser.g:320:3: RULE_DOUBLE
            {
             before(grammarAccess.getRectAccess().getUryDOUBLETerminalRuleCall_6_0()); 
            match(input,RULE_DOUBLE,FOLLOW_2); 
             after(grammarAccess.getRectAccess().getUryDOUBLETerminalRuleCall_6_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rect__UryAssignment_6"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000020L});

}